unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, ToolWin, Buttons;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;    
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton3: TToolButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    N13: TMenuItem;
    N14: TMenuItem;
    PopupMenu1: TPopupMenu;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N17Click(Sender: TObject);

  private
  public
  end;

const inifile='.\ebook.ini';
      grp1='Port';
      grp2='Memory';
      grp3='Symbols';
var Form1: TForm1;
    lpt,nummc,memtype:word;
    tab:array[0..255] of byte;
procedure saveoptions;
function memsize:integer;

implementation

uses Unit2, Unit3, Unit4;

{$R *.DFM}

function memsize:integer;
begin
result:=1 shl memtype;
end;

procedure loadoptions;
var p:pchar;
    i,e,v:integer;
begin
for i:=0 to 255 do tab[i]:=i;
getmem(p,256);
GetPrivateProfileString(grp1,'Port','',p,256,inifile);
lpt:=$378;
if uppercase(p)='LPT2' then lpt:=$278;
if uppercase(p)='LPT3' then lpt:=$3bc;
GetPrivateProfileString(grp2,'MemoryType','',p,256,inifile);
memtype:=0;
val(p,v,e);
if (e=0) then
   case v of
        2:memtype:=1;
        4:memtype:=2;
        8:memtype:=3;
        16:memtype:=4;
        32:memtype:=5;
        64:memtype:=6;
        128:memtype:=7;
        256:memtype:=8;
        512:memtype:=9;
        end;
GetPrivateProfileString(grp2,'NumMC','',p,256,inifile);
nummc:=1;
val(p,v,e);
if (e=0)and(v>0)and(v<9) then nummc:=v;
for i:=0 to 255 do
    begin
    GetPrivateProfileString(grp3,pchar(inttostr(i)),'',p,256,inifile);
    val(p,v,e);if (e=0)and(v>0)and(v<256) then tab[i]:=v;
    end;
end;

procedure saveoptions;
var s:string;
    i:byte;
begin
case lpt of
     $378:s:='LPT1';
     $278:s:='LPT2';
     $3bc:s:='LPT3';
     end;
WritePrivateProfileString(grp1,'Port',pchar(s),inifile);
WritePrivateProfileString(grp2,'MemoryType',pchar(inttostr(memsize)),inifile);
WritePrivateProfileString(grp2,'NumMC',pchar(inttostr(nummc)),inifile);
for i:=0 to 255 do
    WritePrivateProfileString(grp3,pchar(inttostr(i)),pchar(inttostr(tab[i])),inifile);
end;

function untab(c:byte):byte;
var i:byte;
begin
result:=0;
for i:=0 to 255 do
    if tab[i]=c then
       begin
       result:=i;
       exit;
       end;
end;

//i2c ---start---
procedure init;assembler;
asm
mov dx,lpt
xor ax,ax
out dx,al
end;

function sclbusy:boolean;
var b:byte;
begin
asm
  mov dx,lpt
  inc dx
  in  al,dx
  mov b,al
end;
result:=((b and 32)=0);
end;

function i2cbusy:boolean;
var i:integer;
    b:byte;
begin
for i:=1 to 1000 do
    if sclbusy then
       begin result:=true;exit;end;
result:=false;
end;

procedure waitbusy;
begin
while i2cbusy do;
end;

procedure Pause;assembler;
asm
 push ax
@@0:
 jmp @@1
@@1:
 in al, dx
 pop ax
end;

procedure Start; assembler;
asm
 mov dx, lpt
 mov al, 00000000b {SCL = 1, SDA = 1}
 out dx, al
 call Pause
 mov al, 00000010b {SCL = 1, SDA = 0}
 out dx, al
 call Pause
 mov al, 00000011b {SCL = 0, SDA = 0}
 out dx, al
 call Pause
end;

procedure Stop; assembler;
asm
 mov dx, lpt
 mov al, 00000010b {SCL = 1, SDA = 0}
 out dx, al
 call Pause
 mov al, 00000000b {SCL = 1, SDA = 1}
 out dx, al
 call Pause
end;

function PutByte(B: Byte): boolean; assembler;
asm
 mov dx, lpt
 mov ah, B
 mov ecx, 8
@@0:
 rcl ah,1
 jc @@1
 mov al, 00000011b {SCL = 0, SDA = 0}
 out dx, al
 call Pause
 mov al, 00000010b {SCL = 1, SDA = 0}
 out dx, al
 call Pause
 mov al, 00000011b {SCL = 0, SDA = 0}
 out dx, al
 jmp @@2
@@1:
 mov al, 00000001b {SCL = 0, SDA = 1}
 out dx, al
 call Pause
 mov al, 00000000b {SCL = 1, SDA = 1}
 out dx, al
 call Pause
 mov al, 00000001b {SCL = 0, SDA = 1}
 out dx, al
@@2:
 loop @@0
 call Pause
 mov al, 00000000b {SCL = 1, SDA = 1}
 out dx, al
 call Pause
 inc dx
 in al, dx
 dec dx
 and al, 00010000b
 mov ah, 1
 je @@3
 mov ah, 0
@@3:
 mov al, 00000001b {SCL = 0, SDA = 1}
 out dx, al
 mov al, ah
end;

function GetByte: byte; assembler;
asm
 mov dx, lpt
 mov ecx, 8
@@0:
 mov al, 00000000b {SCL = 1, SDA = 1}
 out dx, al
 call Pause
 inc dx
 in al, dx
 dec dx
 and al, 00010000b
 shl al,1
 shl al,1
 shl al,1
 shl al,1
 rcl ah,1
 mov al, 00000001b {SCL = 0, SDA = 1}
 out dx, al
 call Pause
 loop @@0
 mov al, 00000000b {SCL = 1, SDA = 1}
 out dx, al
 call Pause
 mov al, 00000001b {SCL = 0, SDA = 1}
 out dx, al
 call Pause
 mov al, ah
end;

var error:boolean;

procedure WriteByte(nummc,Addr:Word; B : Byte);
begin
 error:=false;
 Start;
 if not PutByte(160+nummc shl 1) then error:=true;
 if not PutByte(hi(addr)) then error:=true;
 if not PutByte(Lo(Addr)) then error:=true;
 if not PutByte(B) then error:=true;
 Stop;
// Delay(5);
end;

function ReadByte(nummc,Addr:Word): Byte;
begin
 error:=false;
 Start;
 if not PutByte(160+nummc shl 1)  then  error:=true;
 if not PutByte(hi(addr)) then error:=true;
 if not PutByte(Lo(Addr)) then error:=true;
 Start;
 if not PutByte(161+nummc shl 1) then error:=true;
 ReadByte := GetByte;
 Stop;
end;

//i2c ---end---

procedure TForm1.N4Click(Sender: TObject);
begin
if opendialog1.execute then
   memo1.Lines.loadfromfile(opendialog1.filename);
end;

procedure TForm1.N5Click(Sender: TObject);
begin
if savedialog1.execute then
   memo1.Lines.savetofile(savedialog1.filename);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
N4Click(sender);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
N5Click(sender);
end;

procedure TForm1.N7Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
n8click(sender);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
n9click(sender);
end;

procedure TForm1.N8Click(Sender: TObject);
var buf:pchar;
    size,ms:integer;
    i,j:word;
    p:integer;
    v:byte;
label endp;    
begin                     //write to ebook
form3.show;
form3.ProgressBar1.position:=0;
buf:=memo1.lines.gettext;
size:=length(buf);       //text size
ms:=memsize*128*nummc;   //mem size
form3.show;
form3.ProgressBar1.position:=0;
waitbusy;
for i:=0 to nummc-1 do
    for j:=0 to memsize*128-1 do
        begin
        p:=i*memsize*128+j;
        form3.ProgressBar1.position:=p*100 div ms;
        if p<size then v:=byte(buf[p]) else v:=32;
        WriteByte(i,j,tab[v]);
//        while (sclbusy) do;
        sleep(4);                 
        //        sleep(2);
        if error then
           begin
           application.messagebox(pchar('     '+inttostr(i)+'   '+inttohex(j,4)+'h'),'',mb_ok);
           goto endp;
           end;
        end;
endp:;
form3.hide;
end;

procedure TForm1.N9Click(Sender: TObject);
var buf:pchar;
    i,j:word;
    p,ms:integer;
label endp;
begin                     //read to ebook
getmem(buf,memsize*128*nummc);
buf[0]:=#0;
ms:=memsize*128*nummc;
form3.show;
form3.ProgressBar1.position:=0;
waitbusy;
for i:=0 to nummc-1 do
    for j:=0 to memsize*128-1 do
        begin
        p:=i*memsize*128+j;
        form3.ProgressBar1.position:=p*100 div ms;
        buf[p]:=char(untab(readbyte(i,j)));
        if error then
           begin
           application.messagebox(pchar('     '+inttostr(i)+'   '+inttohex(j,4)+'h'),'',mb_ok);
           goto endp;
           end;
        end;
endp:;
form3.hide;
memo1.lines.settext(buf);        
freemem(buf);
end;

procedure TForm1.N11Click(Sender: TObject);
begin
aboutbox.showmodal;
end;

procedure TForm1.N10Click(Sender: TObject);
begin
options.showmodal;
init;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
loadoptions;
init;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
statusbar1.panels[0].text:=inttostr(length(memo1.lines.gettext))+' ';
statusbar1.panels[1].text:=inttostr(memo1.lines.count)+' (,)';
end;

procedure TForm1.N13Click(Sender: TObject);
begin
memo1.lines.clear;
end;

procedure TForm1.SpeedButtonClick(Sender: TObject);
begin
if sender=SpeedButton1 then N4Click(sender);
if sender=SpeedButton2 then N5Click(sender);
if sender=SpeedButton3 then N8Click(sender);
if sender=SpeedButton4 then N9Click(sender);
if sender=SpeedButton5 then N13Click(sender);
end;

procedure TForm1.N14Click(Sender: TObject);
begin
Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TForm1.N18Click(Sender: TObject);
begin
memo1.SelectAll;
end;

procedure TForm1.N15Click(Sender: TObject);
begin
memo1.clearselection;
end;

procedure TForm1.N16Click(Sender: TObject);
begin
memo1.copytoclipboard;
end;

procedure TForm1.N17Click(Sender: TObject);
begin
memo1.pastefromclipboard;
end;

end.
